import psycopg2
import sys
import logger

#set up stuff
conn1 = psycopg2.connect(
   database="testdb", user='madden', password='', host='127.0.0.1', port= '5432'
)
conn2 = psycopg2.connect(
   database="testdb", user='madden', password='', host='127.0.0.1', port= '5433'
)
conn1.autocommit = True
conn2.autocommit = True

conns = [conn1, conn2]
logger = logger.logger(conns)

logger.recover()
print("recovery completed")

workers = []
for conn in conns:
    worker = conn.cursor()
    workers.append(worker)





def do_work(cursor):
    cursor.execute("update t set f = f + 1")


all_prepared = True


tid = logger.start_coord_txn()  #log START, get TID

for worker in workers:
    logger.start_worker_txn(worker, tid)  # issue BEGIN TRANSACTION to worker
    do_work(worker)
    result = logger.prepare(worker, tid)  # PREPARE worker
    all_prepared = all_prepared & result

if (all_prepared):
    logger.log(tid,"COMMIT")
else:
    logger.log(tid,"ABORT")


print("committing, all prepared = %d"%(all_prepared))

for worker in workers:
    if (all_prepared):
        logger.commit(worker, tid)  
    else:
        logger.abort(worker, tid)

logger.log(tid,"DONE")
print("done")




